<script>
    import BarPlot from './plot_components/BarPlot.svelte';
    import AreaPlot from './plot_components/AreaPlot.svelte';
    import LinePlot from './plot_components/LinePlot.svelte';
    // import AnnotationPlot from './plot_components/AnnotationPlot.svelte';
    import ImageIntervalPlot from './plot_components/ImageIntervalPlot.svelte';
    import ImageEpochPlot from './plot_components/ImageEpochPlot.svelte';
    import EventSymbolsPlot from './plot_components/EventSymbolsPlot.svelte';
    import ForecastPlot from './plot_components/ForecastPlot.svelte';
    import LoadingIndicator from './LoadingIndicator.svelte';
    import ColorMappedSymbolsPlot from './plot_components/ColorMappedSymbolsPlot.svelte';
    import { dataStore } from './stores/dataProductStore.js';
    import { fade } from 'svelte/transition';

    export let plotElement;
    export let subplot;
    export let xScale;

    let viewData = false;
    let cache = {};

    const cache_data = async function(plotElement, data) {
        cache[plotElement.dataset] = await data;
    }

</script>

<!-- These plot types are currently not associated with datasets on the HAPI server.
They are for testing only -->

{#if plotElement.plot_options.plot_type == "image_interval"}
    <ImageIntervalPlot xScale={xScale} yScale={subplot.yScale} plotElement={plotElement}/>
{:else if plotElement.plot_options.plot_type == "image_epoch"}
    <ImageEpochPlot xScale={xScale} yScale={subplot.yScale}/>
{:else if plotElement.plot_options.plot_type == "events_symbols"}
    <EventSymbolsPlot {plotElement} {xScale} yScale={subplot.yScale}/>
{/if}

<!-- End of test plot types. Other plot types should wait for data to be loaded -->

{#await dataStore.load()}
    <LoadingIndicator x={xScale.range()[0]+20} y={subplot.y+subplot.h-30} scale=0.4 fill="#888"/>
    <!-- <text x={xScale.range()[0]+40} y={subplot.y+subplot.h-20}>Data is being loaded</text> -->
{:then}
    {#if plotElement.dataset in cache}
        <g class={"plot_element_" + plotElement.dataset}>
            {#if "issue_time_parameter" in plotElement}
                <ForecastPlot {plotElement} data={cache[plotElement.dataset]} {xScale} yScale={subplot.yScale}/>
            {:else}
                {#if plotElement.plot_options.plot_type == "bars"}
                    <BarPlot {plotElement} data={cache[plotElement.dataset]} cadence={$dataStore[plotElement.dataset].cadence} xScale={xScale} yScale={subplot.yScale}/>
                {:else if plotElement.plot_options.plot_type == "area"}
                    <AreaPlot {plotElement} data={cache[plotElement.dataset]} {xScale} yScale={subplot.yScale}/>
                {:else if plotElement.plot_options.plot_type == "line"}
                    <LinePlot {plotElement} data={cache[plotElement.dataset]} {xScale} yScale={subplot.yScale}/>
                {:else if plotElement.plot_options.plot_type == "colormappedsymbols"}
                    <ColorMappedSymbolsPlot {plotElement} data={cache[plotElement.dataset]} {xScale} yscale={subplot.yScale}/>
                {:else if plotElement.plot_options.plot_type == "events_symbols"}
                {:else if plotElement.plot_options.plot_type == "image_epoch"}
                {:else if plotElement.plot_options.plot_type == "image_interval"}
                {:else}
                    <text x={xScale.range()[0]+20} y={subplot.y+subplot.h-20}>Unknown plot type: {plotElement.plot_options.plot_type}</text>
                {/if}
            {/if}
        </g>
        <LoadingIndicator x={xScale.range()[0]+20} y={subplot.y+subplot.h-30} scale=0.4 fill="#888"/>
        <text x={xScale.range()[0]+20} y={subplot.y+subplot.h-20}>Data from cache</text>
    {:else if plotElement.dataset in $dataStore}
        {#await $dataStore[plotElement.dataset].data}
            <LoadingIndicator x={xScale.range()[0]+20} y={subplot.y+subplot.h-30} scale=0.4 fill="#888"/>
        {:then data}
            <g class={"plot_element_" + plotElement.dataset}>
                {#if "issue_time_parameter" in plotElement}
                    <ForecastPlot {plotElement} data={data} {xScale} yScale={subplot.yScale}/>
                {:else}
                    {#if plotElement.plot_options.plot_type == "bars"}
                        <BarPlot plotElement={plotElement} data={data} cadence={$dataStore[plotElement.dataset].cadence} xScale={xScale} yScale={subplot.yScale}/>
                    {:else if plotElement.plot_options.plot_type == "area"}
                        <AreaPlot {plotElement} {data} {xScale} yScale={subplot.yScale}/>
                    {:else if plotElement.plot_options.plot_type == "line"}
                        <LinePlot {plotElement} {data} {xScale} yScale={subplot.yScale}/>
                    {:else if plotElement.plot_options.plot_type == "colormappedsymbols"}
                        <ColorMappedSymbolsPlot {plotElement} {data} {xScale} yScale={subplot.yScale}/>
                    <!-- {:else if plotElement.plot_options.plot_type == "annotation_max"}
                        <AnnotationPlot {plotElement} {data} {xScale} yScale={subplot.yScale}/> -->
                    {:else if plotElement.plot_options.plot_type == "events_symbols"}
                    {:else if plotElement.plot_options.plot_type == "image_epoch"}
                    {:else if plotElement.plot_options.plot_type == "image_interval"}
                    {:else}
                        <text x={xScale.range()[0]+20} y={subplot.y+subplot.h-20}>Unknown plot type: {plotElement.plot_options.plot_type}</text>
                    {/if}
                {/if}
            </g>
        {/await}
    {:else}
        <LoadingIndicator x={xScale.range()[0]+20} y={subplot.y+subplot.h-30} scale=0.4 fill="#844"/>
        <!-- <text x={xScale.range()[0]+40} y={subplot.y+subplot.h-20}>{plotElement.dataset} not available</text> -->
    {/if}
{/await}

<style>
</style>
